var CyberloafCat = CyberloafCat || {};
CyberloafCat.Shower = CyberloafCat.Shower || {};

const SHOWER_FATIGUE_RECOVER_BASE = 0.5;

const BATTLEBACK1_SHOWER_NAME = 'shower';

Object.defineProperty(Game_Party.prototype, "isInShowerBattle", {
    get: function() {
        return this._isInShowerBattle;
    }, configurable: true
});

Game_Party.prototype.setIsInShowerBattleFlag = function(status) {
    this._isInShowerBattle = status;
}

Game_Party.prototype.preShowerBattleSetup = function() {
    let actor = $gameActors.actor(ACTOR_KARRYN_ID);
    BattleManager.setEnemySneakAttackBattle();
    this.setIsInShowerBattleFlag(true);
    this.preBattleSetup();

    actor._showerBattleExit = false;;
    $gameMap.changeBattleback(BATTLEBACK1_SHOWER_NAME, null);

    this.increaseFatigueGain(SHOWER_FATIGUE_RECOVER_BASE * -1 * actor.fatigueRecoveryRate(), true);
    actor.preShowerBattleSetup();
}

Game_Party.prototype.postShowerBattleCleanup = function() {
    this.setIsInShowerBattleFlag(false);
    // TODO: today shower event finished
    let actor = $gameActors.actor(ACTOR_KARRYN_ID);
    actor.putOnGlovesAndHat();
    actor.changeToWardenClothing();
}

/// Game Actor
Game_Actor.prototype.preShowerBattleSetup = function() {
    this.preBattleSetup();
	this.setAsNoHalberdBattle();
	this.removeState(STATE_CONFIDENT_ID);
	this.takeOffPanties();
	this.removeClothing();
    this.removeAllToys();

    this.setShowerStandingPose();
    this.showerBattle_resetRightArmToNormal();
    
    // TODO: record

}

Game_Actor.prototype.showerBattle_makeSexualNoise = function(value) {
    // TODO: make sexual noise
    /*
    when taking a shower, Karryn can masturbate, which will get others notice,
    guild or prisoner may try to peek, or try to join her shower.

    here is the method to calculate the sexual noise Karry make, is similar to
    glory hole event.
    */
}

/// Skills
Game_Actor.prototype.customReq_showerBreather = function() {
    if (this.justOrgasmed()) {
        return true;
    }
    if(this.hasNoStamina()) {
        return false;
    }
    return true;
}

Game_Actor.prototype.skillCost_gloryBreather = function() {
	return 0;
};

Game_Actor.prototype.afterEval_showerBreather = function() {
    this.resetSexSkillConsUsage(false);
    this.setupShowerTachieForArea();
}

Game_Actor.prototype.showerRestEffect = function() {
    let fatigueRecovery = SHOWER_FATIGUE_RECOVER_BASE;
    $gameParty.increaseFatigueGain(fatigueRecovery * -1 * this.fatigueRecoveryRate(), true);
}

Game_Actor.prototype.customReq_showerWashSkill = function(area) {
    return true;
}

Game_Actor.prototype.dmgFormula_showerWashSkill = function(area) {
    let target = this;
    let hitBySkillTypeSet = false;

    let enemySkillLevel = this.masturbateLvl();
    let enemySkillRating = this.masturbateSkillRating();
    let staminaPercent = target.hp / target.mhp;

    let baseDmg = 0;
    let targetDesire = 0;
    let targetSensitivity = 0;

    switch(area) {
        case AREA_BOOBS:
            // in fact taking a shower should not be consider as masturbate,
            // i may change this latter.
            baseDmg = BASEDMG_PETTING_BOOBS;
            targetDesire = target.boobsDesire;
            targetSensitivity = target.boobsSensitivity();
            // this.addToActorBoobsPettedRecord(false, false, true);
        break;
        case AREA_PUSSY:
            baseDmg = BASEDMG_PETTING_PUSSY;
            targetDesire = target.pussyDesire;
            targetSensitivity = target.pussySensitivity();
            // this.addToActorPussyPettedRecord(false, false, true);
        break;
        case AREA_BUTT:
            baseDmg = BASEDMG_PETTING_BUTT;
            targetDesire = target.buttDesire;
            targetSensitivity = target.buttSensitivity();
            // this.addToActorButtPettedRecord(false, false, true);
        break;
        default:
            console.error("Error dmgFormula shower area: " + area);
    }

    // should no gain too much desire and pleasure while taking a shower
    let targetDesireGain = (baseDmg + enemySkillLevel) * targetPettingRate / 3;
	let targetPleasureGain = (targetDesireGain + this.dex * 1.3) * enemySkillRating * targetPettingRate * targetSensitivity / 3;
	// targetPleasureGain *= target.passivePettingPleasureRate();
	
	let targetPleasureUpperCap = target.getValueOfOrgasmFromPercent((VAR_PLEASURE_UPPER_CAP_COEFF_ONE + (target.slutLvl + 1) * VAR_PLEASURE_UPPER_CAP_COEFF_TWO) * targetSensitivity * targetPettingRate * (VAR_PLEASURE_UPPER_CAP_COEFF_THREE + targetDesire * VAR_PLEASURE_UPPER_CAP_COEFF_FOUR));
	targetPleasureGain = Math.min(targetPleasureGain, targetPleasureUpperCap);
	
	
	let staminaDmg = target.skillCost_karrynOnaniInBattleSkills();
    let result = target.result();
	result.pleasureDamage = targetPleasureGain;
	result.desireAreaDamage = targetDesireGain * .6;
	result.desireRandomDamage = targetDesireGain * .4;
	result.desireCockWeight = 3;
	result.desireTarget = area;

	switch(area) {
	case AREA_BOOBS:
		target.addToActorBoobsPleasureRecord(targetPleasureGain);
	break;
	case AREA_PUSSY:
		target.addToActorPussyPleasureRecord(targetPleasureGain);
	break;
	case AREA_BUTT:
		target.addToActorButtPleasureRecord(targetPleasureGain);
	break;
	}

    return staminaDmg;
}

Game_Actor.prototype.afterEval_showerWashSkill = function(area) {
    // TODO: record
    switch(area) {
        case AREA_BOOBS:
            BattleManager._logWindow.displayRemLine(CyberloafCat.Lines.getMessage(KSJ_karryn_shower_touchBoobs_exp0));
        break;
        case AREA_PUSSY:
            BattleManager._logWindow.displayRemLine(CyberloafCat.Lines.getMessage(KSJ_karryn_shower_touchPussy_exp0));
        break;
        case AREA_BUTT:
            BattleManager._logWindow.displayRemLine(CyberloafCat.Lines.getMessage(KSJ_karryn_shower_touchButt_exp0));
        break;
        }
    
    this.setupShowerTachieForArea(area);
    this.resetSexSkillConsUsage(false);
    this.showerRestEffect();
}

Game_Actor.prototype.beforeEval_showerRefundCost = function(cost) {
	this.setHp(Math.round(this.hp + cost));
};
Game_Actor.prototype.beforeEval_showerSpendCost = function(cost) {
	this.setHp(Math.round(this.hp - cost));
};

Game_Actor.prototype.afterEval_showerSkillExit = function() {
	this._showerBattleExit = true;
};

/// Tachie
Game_Actor.prototype.setupShowerTachieForArea = function(area) {
    this.setAllowTachieUpdate(false);
    var tachieRightArmName = '';
    var tachieLeftArmName = '';
    switch(area) {
        case AREA_BOOBS:
            tachieLeftArmName = 'touch_boobs';
        break;
        case AREA_PUSSY:
            tachieRightArmName = 'touch_crotch';
        break;
        case AREA_BUTT:
            tachieLeftArmName = 'touch_butt';
        break;
    }
    if (tachieLeftArmName.length > 0) {
        this.setTachieLeftArm(tachieLeftArmName);
        this.showerBattle_resetRightArmToNormal();
    } else if (tachieRightArmName.length > 0) {
        this.setTachieRightArm(tachieRightArmName);
        this.showerBattle_resetLeftArmToNormal();
    } else {
        this.setTachieLeftArm('normal');
        this.showerBattle_resetRightArmToNormal();
    }
    
    this.emoteShowerStandingPose();
    this.setAllowTachieUpdate(true);
}

Game_Actor.prototype.showerBattle_resetLeftArmToNormal = function() {
    this.setTachieLeftArm('normal');
    this.setTachieFrontC('shower_head_left');
}

Game_Actor.prototype.showerBattle_resetRightArmToNormal = function() {
    this.setTachieRightArm('normal');
    this.setTachieFrontC('shower_head_right');
}


/// Game Troop
Game_Troop.prototype.setup_showerBattle = function(troopId) {
	this._toiletObs = new Game_Enemy(ENEMY_SHOWER_OBS_ID, 0, 0, false, ENEMY_SHOWER_OBS_ID);
	this._enemies.push(this._toiletObs);
};

/// Game Enemy
Game_Enemy.prototype.enemyBattleAIShower = function(target) {
	if(this.enemyType() == ENEMYTYPE_SHOWER_OBS_TAG) return;
}