var CyberloafCat = CyberloafCat || {};
CyberloafCat.ShowerEmote = CyberloafCat.ShowerEmote || {};

CyberloafCat.ShowerEmote.Game_EmoteMasterManager = Game_Actor.prototype.emoteMasterManager;
Game_Actor.prototype.emoteMasterManager = function() {
    if ($gameParty.isInShowerBattle) {
        this.emoteMasterManager_ShowerBattle();
		return;
    }
    CyberloafCat.ShowerEmote.Game_EmoteMasterManager.call(this);
}

Game_Actor.prototype.emoteMasterManager_ShowerBattle = function() {
	if(this._emoteMasterManagerForShowerBattleIsRunning) return;
	this._emoteMasterManagerForShowerBattleIsRunning = true;
	let pose = this.poseName;
	switch(pose){
	case POSE_SHOWER_STANDING:
		this.emoteShowerStandingPose();
		break;
	}
	this._emoteMasterManagerForShowerBattleIsRunning = false;
};


Game_Actor.prototype.emoteShowerStandingPose = function() {
    this.setAllowTachieEmoteUpdate(false);

    let justOrgasmed = this.didLastGetHitBySkillType(JUST_SKILLTYPE_KARRYN_ORGASM);
	let isAroused = this.isAroused() || justOrgasmed;
    
    
    let isTouchingBoobs = this.tachieLeftArm.includes('touch_boobs');
    let isTouchingButt = this.tachieLeftArm.includes('touch_butt');
    let isTouchingNipple = this.tachieLeftArm.includes('touch_nipple');
    let isTouchingCrotch = this.tachieRightArm.includes('touch_crotch');

    // let generallvl3 = generalReactionScore >= VAR_DEF_RS_LV3_REQ;
	// let generallvl2 = generalReactionScore >= VAR_DEF_RS_LV2_REQ;
	// let orgasmlvl3 = orgasmReactionScore >= VAR_DEF_RS_LV3_REQ;
	// let orgasmlvl2 = orgasmReactionScore >= VAR_DEF_RS_LV2_REQ;

    let faceArray = [];
	this.resetTachieHoppe();
	this.resetTachieSweat();
    this.resetTachieFrontA();

    if (isTouchingBoobs) {
        this.setTachieLeftArm('touch_boobs');
        this.setTachieFrontA('boob_bubble');
    } else if (isTouchingButt) {
        this.setTachieLeftArm('touch_butt');
        this.setTachieFrontA('butt_bubble');
    } else if (isTouchingNipple) {
        this.setTachieLeftArm('touch_nipple');
    } else {
        this.setTachieLeftArm('normal');
    }

    if (isTouchingCrotch) {
        this.setTachieRightArm('touch_crotch');
        this.setTachieFrontA('crotch_bubble');
    } else {
        this.setTachieRightArm('normal');
    }

    if (isTouchingBoobs || isTouchingNipple) {
        // TODO: general level
        if (isAroused) {
            faceArray.push(3);
            faceArray.push(4);
        } else {
            faceArray.push(7);
            faceArray.push(2);
        }   
    } else if (isTouchingCrotch || isTouchingButt) {
        if (isAroused) {
            faceArray.push(3);
            faceArray.push(4);
        } else {
            faceArray.push(1);
            faceArray.push(7);
        }
    }
    faceArray.push(5);
    faceArray.push(6);

    let faceId = faceArray[Math.randomInt(faceArray.length)];
	let eyebrowsArray = [];
	let eyesArray = [];
	let mouthArray = [];
    let tachieHeadType = 'normal';

    if (faceId === 1)  {    // down head and eye closed
        tachieHeadType = 'down'
        eyebrowsArray.push('nico1');
        eyebrowsArray.push('nico2');
        eyesArray.push('yoko4');
        eyesArray.push('toji1');
        mouthArray.push('mu1');
    } else if (faceId === 2) {      // normal head and eye closed
        tachieHeadType = 'normal';
        eyebrowsArray.push('nico1');
        eyebrowsArray.push('nico2');
        eyesArray.push('toji1');
        mouthArray.push('mu1');
    } else if (faceId === 3) {  // normal head and uneasy eye 
        tachieHeadType = 'normal';
        eyebrowsArray.push('koma1');
        eyebrowsArray.push('oko1');
        eyesArray.push('drunk1');
        eyesArray.push('toji1');
        eyesArray.push('mae2');
        mouthArray.push('mu1');
    } else if (faceId === 4) {  // down head and unesay eye
        tachieHeadType = 'down';
        eyebrowsArray.push('koma1');
        eyebrowsArray.push('oko1');
        eyesArray.push('sitayoko1');
        eyesArray.push('urumae2');
        eyesArray.push('yoko4');
        mouthArray.push('mu1');
    } else if (faceId === 5) {  // down head relex eye open
        tachieHeadType = 'down';
        eyebrowsArray.push('nico1');
        eyebrowsArray.push('nico2');
        eyesArray.push('sitayoko1');
        eyesArray.push('urumae2');
        eyesArray.push('yoko4');
        mouthArray.push('nico2');
        mouthArray.push('mu1');
    } else if (faceId === 6) {  // normal head relex eye open
        tachieHeadType = 'normal';
        eyebrowsArray.push('nico1');
        eyebrowsArray.push('nico2');
        eyesArray.push('mae2');
        mouthArray.push('mu1');
    } else if (faceId === 7) {  // normal head happy
        tachieHeadType = 'normal';
        eyebrowsArray.push('nico1');
        eyebrowsArray.push('nico2');
        eyesArray.push('toji1');
        eyesArray.push('toji2');
        eyesArray.push('yoko4');
        mouthArray.push('nico2');
    }
    this.setTachieHead(tachieHeadType);
    if(eyebrowsArray.length > 0) {
		this.setTachieEyebrows('' + tachieHeadType + '_' + eyebrowsArray[Math.randomInt(eyebrowsArray.length)]);
	}
	if(eyesArray.length > 0) {
		this.setTachieEyes('' + tachieHeadType + '_' + eyesArray[Math.randomInt(eyesArray.length)]);
	}
    if(mouthArray.length > 0) {
		this.setTachieMouth('' + tachieHeadType + '_' + mouthArray[Math.randomInt(mouthArray.length)]);
	}

    this.setAllowTachieEmoteUpdate(true);
}