// #MODS TXT LINES:
//    {"name":"KarrynSideJobs","status":true,"description":"","parameters":{"Debug":"0"}},
//    {"name":"KSJ_Battle","status":true,"description":"","parameters":{"Debug":"0"}},
//    {"name":"KSJ_Enemy","status":true,"description":"","parameters":{"Debug":"0"}},
//    {"name":"KSJ_Layer","status":true,"description":"","parameters":{"Debug":"0"}},
//    {"name":"KSJ_Layout","status":true,"description":"","parameters":{"Debug":"0"}},
//    {"name":"KSJ_Lines","status":true,"description":"","parameters":{"Debug":"0"}},
//    {"name":"KSJ_Shower","status":true,"description":"","parameters":{"Debug":"0"}},
//    {"name":"KSJ_ShowerEmote","status":true,"description":"","parameters":{"Debug":"0"}},
//    {"name":"KSJ_ShowerPose","status":true,"description":"","parameters":{"Debug":"0"}},
//    {"name":"KSJ_Skills","status":true,"description":"","parameters":{"Debug":"0"}},
// #MODS TXT LINES END

var CyberloafCat = CyberloafCat || {};
CyberloafCat.SideJobs = CyberloafCat.SideJobs || {};

const SIDEJOB_VERSION_START = 100;
const SIDEJOB_VERSION_1 = 101;
const SIDEJOB_VERSION_END = SIDEJOB_VERSION_1;

CyberloafCat.SideJobs.preShowerBattleSetup = function() {
    $gameParty.preShowerBattleSetup();
}

CyberloafCat.SideJobs.postShowerBattleCleanup = function() {
    $gameParty.postShowerBattleCleanup();
}

CyberloafCat.initialize = function() {
    let actor = $gameActors.actor(ACTOR_KARRYN_ID);

    if (typeof actor._SideJobsVersion === 'undefined') {
        actor._SideJobsVersion = SIDEJOB_VERSION_START;
    }
    if (actor._SideJobsVersion < SIDEJOB_VERSION_1) {
        CyberloafCat.Skills.setupSideJobSkills(actor);
    }
    actor._SideJobsVersion = SIDEJOB_VERSION_END;
}

CyberloafCat.SideJobs.Game_LoadGamePrison = Game_Party.prototype.loadGamePrison;
Game_Party.prototype.loadGamePrison = function() {
    // TODO: preload setting
    CyberloafCat.SideJobs.Game_LoadGamePrison.call(this);
    CyberloafCat.initialize();
};

CyberloafCat.SideJobs.Game_Party_setupPrison = Game_Party.prototype.setupPrison;
Game_Party.prototype.setupPrison = function() {
    CyberloafCat.SideJobs.Game_Party_setupPrison.call(this);
    CyberloafCat.initialize();
};
