var CyberloafCat = CyberloafCat || {};
CyberloafCat.Battle = CyberloafCat.Battle || {};

CyberloafCat.Battle.Game_setup = Game_Troop.prototype.setup;
Game_Troop.prototype.setup = function(troopId) {
    this.clear();
    this._troopId = troopId;
    this._enemies = [];
	this._enemySpots = [ false, false, false, false, false, false ];
	this._lastEnemySlotToCum = -1;

    if($gameParty.isInShowerBattle) {
        this.setup_showerBattle(troopId);
        return;
    }
    CyberloafCat.Battle.Game_setup.call(this, troopId);
}

CyberloafCat.Battle.Game_CheckBattleEndJobs = BattleManager.checkBattleEndJobs;
BattleManager.checkBattleEndJobs = function() {
    let actor = $gameActors.actor(ACTOR_KARRYN_ID);
    if ($gameParty.isInShowerBattle) {
        if(actor._showerBattleExit) {
            this.processVictory();  // always victory now
            return true;
		}
    }
    return CyberloafCat.Battle.Game_CheckBattleEndJobs.call(this);
}